/**
 * CloneTrooper API
 * CloneTrooper API
 *
 * OpenAPI spec version: 0.0.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

import * as querystring from "querystring";
import * as url from "url";

import * as isomorphicFetch from "isomorphic-fetch";
import * as assign from "core-js/library/fn/object/assign";

interface Dictionary<T> { [index: string]: T; }
export interface FetchAPI { (url: string, init?: any): Promise<any>; }

const BASE_PATH = "/api/v1/cluster".replace(/\/+$/, "");

export interface FetchArgs {
    url: string;
    options: any;
}

export class BaseAPI {
    basePath: string;
    fetch: FetchAPI;

    constructor(fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) {
        this.basePath = basePath;
        this.fetch = fetch;
    }
};

/**
 * A printer in a cluster
 */
export interface DiscoveredPrinter {
    "name"?: string;
    "guid"?: Uuid;
    "state"?: DiscoveredPrinterStateEnum;
    "ip_address"?: string;
}

export type DiscoveredPrinterStateEnum = "discovered" | "auth_request" | "auth_verify" | "auth_failed";
export interface InlineResponse201 {
    "message"?: string;
    "uuid"?: Uuid;
}

export interface InlineResponse2011 {
    "message"?: string;
}

export interface InlineResponse404 {
    "error"?: ModelError;
}

/**
 * Error message returned by an unsuccesfull call
 */
export interface ModelError {
    "code"?: number;
    "message"?: string;
}

/**
 * A print job that needs to take place / is taking place / has taken place
 */
export interface PrintJob {
    "id"?: number;
    "time_elapsed"?: number;
    "time_remaining"?: number;
    "name"?: string;
    "uuid"?: Uuid;
    "printer"?: Uuid;
    "state"?: PrintJobStateEnum;
}

export type PrintJobStateEnum = "none" | "printing" | "pausing" | "paused" | "resuming" | "pre_print" | "post_print" | "wait_cleanup" | "finished" | "sending" | "sent" | "not_started";
/**
 * A printer in a cluster
 */
export interface Printer {
    "guid"?: Uuid;
    "name"?: string;
    "state"?: PrinterStateEnum;
    "ip_address"?: string;
    "job"?: PrintJob;
}

export type PrinterStateEnum = "booting" | "idle" | "printing" | "error" | "maintenance";
/**
 * UUID in uuid4 format.
 */
export type Uuid = string;



/**
 * DefaultApi - fetch parameter creator
 */
export const DefaultApiFetchParamCreator = {
    /** 
     */
    discoveredprintersGet(options?: any): FetchArgs {
        const baseUrl = `/discoveredprinters`;
        let urlObj = url.parse(baseUrl, true);
        let fetchOptions: RequestInit = assign({}, { method: "GET" }, options);

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
    /** 
     * Re-scan for printers. The cluster continuously listens for new printers on the network. However, occasionally you want to re-initate the scan if discovery failed.
     */
    discoveredprintersScanPost(options?: any): FetchArgs {
        const baseUrl = `/discoveredprinters/scan`;
        let urlObj = url.parse(baseUrl, true);
        let fetchOptions: RequestInit = assign({}, { method: "POST" }, options);

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
    /** 
     */
    jobsGet(options?: any): FetchArgs {
        const baseUrl = `/jobs`;
        let urlObj = url.parse(baseUrl, true);
        let fetchOptions: RequestInit = assign({}, { method: "GET" }, options);

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
    /** 
     * @param id id of the job to get
     */
    jobsIdGet(params: {  "id": string; }, options?: any): FetchArgs {
        // verify required parameter "id" is set
        if (params["id"] == null) {
            throw new Error("Missing required parameter id when calling jobsIdGet");
        }
        const baseUrl = `/jobs/{id}`
            .replace(`{${"id"}}`, `${ params["id"] }`);
        let urlObj = url.parse(baseUrl, true);
        let fetchOptions: RequestInit = assign({}, { method: "GET" }, options);

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
    /** 
     * @param filename Name of print job
     * @param file File that needs to be printed (.gcode, .gcode.gz)
     */
    jobsPost(params: {  "filename": string; "file": any; }, options?: any): FetchArgs {
        // verify required parameter "filename" is set
        if (params["filename"] == null) {
            throw new Error("Missing required parameter filename when calling jobsPost");
        }
        // verify required parameter "file" is set
        if (params["file"] == null) {
            throw new Error("Missing required parameter file when calling jobsPost");
        }
        const baseUrl = `/jobs`;
        let urlObj = url.parse(baseUrl, true);
        let fetchOptions: RequestInit = assign({}, { method: "POST" }, options);

        let contentTypeHeader: Dictionary<string>;
        contentTypeHeader = { "Content-Type": "application/x-www-form-urlencoded" };
        fetchOptions.body = querystring.stringify({
            "filename": params["filename"],
            "file": params["file"],
        });
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
    /** 
     */
    printersGet(options?: any): FetchArgs {
        const baseUrl = `/printers`;
        let urlObj = url.parse(baseUrl, true);
        let fetchOptions: RequestInit = assign({}, { method: "GET" }, options);

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
    /** 
     * Add a new printer to the cluster. This will first add the printer to the discoveredprinters list if it is not there, and then will handle authentication. When authentication was succesful it will be added to the normal printer list.
     * @param hostname Hostname of printer to be added to the cluster. Either this and/or IP needs to be set. In case both are set, hostname is checked first.
     * @param ip IP of printer to be added to the cluster. Either this and/or hostname needs to be set. In case both are set, hostname is checked first.
     */
    printersPost(params: {  "hostname"?: string; "ip"?: string; }, options?: any): FetchArgs {
        const baseUrl = `/printers`;
        let urlObj = url.parse(baseUrl, true);
        let fetchOptions: RequestInit = assign({}, { method: "POST" }, options);

        let contentTypeHeader: Dictionary<string>;
        contentTypeHeader = { "Content-Type": "application/x-www-form-urlencoded" };
        fetchOptions.body = querystring.stringify({
            "hostname": params["hostname"],
            "ip": params["ip"],
        });
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
    /** 
     * Remove a printer from the cluster [NOT YET IMPLEMENTED]
     * @param uuid uuid of the printer to delete
     */
    printersUuidDelete(params: {  "uuid": string; }, options?: any): FetchArgs {
        // verify required parameter "uuid" is set
        if (params["uuid"] == null) {
            throw new Error("Missing required parameter uuid when calling printersUuidDelete");
        }
        const baseUrl = `/printers/{uuid}`
            .replace(`{${"uuid"}}`, `${ params["uuid"] }`);
        let urlObj = url.parse(baseUrl, true);
        let fetchOptions: RequestInit = assign({}, { method: "DELETE" }, options);

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
    /** 
     * @param uuid uuid of the printer to get
     */
    printersUuidGet(params: {  "uuid": string; }, options?: any): FetchArgs {
        // verify required parameter "uuid" is set
        if (params["uuid"] == null) {
            throw new Error("Missing required parameter uuid when calling printersUuidGet");
        }
        const baseUrl = `/printers/{uuid}`
            .replace(`{${"uuid"}}`, `${ params["uuid"] }`);
        let urlObj = url.parse(baseUrl, true);
        let fetchOptions: RequestInit = assign({}, { method: "GET" }, options);

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
};

/**
 * DefaultApi - functional programming interface
 */
export const DefaultApiFp = {
    /** 
     */
    discoveredprintersGet(options?: any): (fetch: FetchAPI, basePath?: string) => Promise<Array<DiscoveredPrinter>> {
        const fetchArgs = DefaultApiFetchParamCreator.discoveredprintersGet(options);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
    /** 
     * Re-scan for printers. The cluster continuously listens for new printers on the network. However, occasionally you want to re-initate the scan if discovery failed.
     */
    discoveredprintersScanPost(options?: any): (fetch: FetchAPI, basePath?: string) => Promise<any> {
        const fetchArgs = DefaultApiFetchParamCreator.discoveredprintersScanPost(options);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response;
                } else {
                    throw response;
                }
            });
        };
    },
    /** 
     */
    jobsGet(options?: any): (fetch: FetchAPI, basePath?: string) => Promise<Array<PrintJob>> {
        const fetchArgs = DefaultApiFetchParamCreator.jobsGet(options);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
    /** 
     * @param id id of the job to get
     */
    jobsIdGet(params: { "id": string;  }, options?: any): (fetch: FetchAPI, basePath?: string) => Promise<PrintJob> {
        const fetchArgs = DefaultApiFetchParamCreator.jobsIdGet(params, options);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
    /** 
     * @param filename Name of print job
     * @param file File that needs to be printed (.gcode, .gcode.gz)
     */
    jobsPost(params: { "filename": string; "file": any;  }, options?: any): (fetch: FetchAPI, basePath?: string) => Promise<InlineResponse201> {
        const fetchArgs = DefaultApiFetchParamCreator.jobsPost(params, options);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
    /** 
     */
    printersGet(options?: any): (fetch: FetchAPI, basePath?: string) => Promise<Array<Printer>> {
        const fetchArgs = DefaultApiFetchParamCreator.printersGet(options);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
    /** 
     * Add a new printer to the cluster. This will first add the printer to the discoveredprinters list if it is not there, and then will handle authentication. When authentication was succesful it will be added to the normal printer list.
     * @param hostname Hostname of printer to be added to the cluster. Either this and/or IP needs to be set. In case both are set, hostname is checked first.
     * @param ip IP of printer to be added to the cluster. Either this and/or hostname needs to be set. In case both are set, hostname is checked first.
     */
    printersPost(params: { "hostname"?: string; "ip"?: string;  }, options?: any): (fetch: FetchAPI, basePath?: string) => Promise<InlineResponse2011> {
        const fetchArgs = DefaultApiFetchParamCreator.printersPost(params, options);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
    /** 
     * Remove a printer from the cluster [NOT YET IMPLEMENTED]
     * @param uuid uuid of the printer to delete
     */
    printersUuidDelete(params: { "uuid": string;  }, options?: any): (fetch: FetchAPI, basePath?: string) => Promise<any> {
        const fetchArgs = DefaultApiFetchParamCreator.printersUuidDelete(params, options);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response;
                } else {
                    throw response;
                }
            });
        };
    },
    /** 
     * @param uuid uuid of the printer to get
     */
    printersUuidGet(params: { "uuid": string;  }, options?: any): (fetch: FetchAPI, basePath?: string) => Promise<Printer> {
        const fetchArgs = DefaultApiFetchParamCreator.printersUuidGet(params, options);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
};

/**
 * DefaultApi - object-oriented interface
 */
export class DefaultApi extends BaseAPI {
    /** 
     */
    discoveredprintersGet(options?: any) {
        return DefaultApiFp.discoveredprintersGet(options)(this.fetch, this.basePath);
    }
    /** 
     * Re-scan for printers. The cluster continuously listens for new printers on the network. However, occasionally you want to re-initate the scan if discovery failed.
     */
    discoveredprintersScanPost(options?: any) {
        return DefaultApiFp.discoveredprintersScanPost(options)(this.fetch, this.basePath);
    }
    /** 
     */
    jobsGet(options?: any) {
        return DefaultApiFp.jobsGet(options)(this.fetch, this.basePath);
    }
    /** 
     * @param id id of the job to get
     */
    jobsIdGet(params: {  "id": string; }, options?: any) {
        return DefaultApiFp.jobsIdGet(params, options)(this.fetch, this.basePath);
    }
    /** 
     * @param filename Name of print job
     * @param file File that needs to be printed (.gcode, .gcode.gz)
     */
    jobsPost(params: {  "filename": string; "file": any; }, options?: any) {
        return DefaultApiFp.jobsPost(params, options)(this.fetch, this.basePath);
    }
    /** 
     */
    printersGet(options?: any) {
        return DefaultApiFp.printersGet(options)(this.fetch, this.basePath);
    }
    /** 
     * Add a new printer to the cluster. This will first add the printer to the discoveredprinters list if it is not there, and then will handle authentication. When authentication was succesful it will be added to the normal printer list.
     * @param hostname Hostname of printer to be added to the cluster. Either this and/or IP needs to be set. In case both are set, hostname is checked first.
     * @param ip IP of printer to be added to the cluster. Either this and/or hostname needs to be set. In case both are set, hostname is checked first.
     */
    printersPost(params: {  "hostname"?: string; "ip"?: string; }, options?: any) {
        return DefaultApiFp.printersPost(params, options)(this.fetch, this.basePath);
    }
    /** 
     * Remove a printer from the cluster [NOT YET IMPLEMENTED]
     * @param uuid uuid of the printer to delete
     */
    printersUuidDelete(params: {  "uuid": string; }, options?: any) {
        return DefaultApiFp.printersUuidDelete(params, options)(this.fetch, this.basePath);
    }
    /** 
     * @param uuid uuid of the printer to get
     */
    printersUuidGet(params: {  "uuid": string; }, options?: any) {
        return DefaultApiFp.printersUuidGet(params, options)(this.fetch, this.basePath);
    }
};

/**
 * DefaultApi - factory interface
 */
export const DefaultApiFactory = function (fetch?: FetchAPI, basePath?: string) {
    return {
        /** 
         */
        discoveredprintersGet(options?: any) {
            return DefaultApiFp.discoveredprintersGet(options)(fetch, basePath);
        },
        /** 
         * Re-scan for printers. The cluster continuously listens for new printers on the network. However, occasionally you want to re-initate the scan if discovery failed.
         */
        discoveredprintersScanPost(options?: any) {
            return DefaultApiFp.discoveredprintersScanPost(options)(fetch, basePath);
        },
        /** 
         */
        jobsGet(options?: any) {
            return DefaultApiFp.jobsGet(options)(fetch, basePath);
        },
        /** 
         * @param id id of the job to get
         */
        jobsIdGet(params: {  "id": string; }, options?: any) {
            return DefaultApiFp.jobsIdGet(params, options)(fetch, basePath);
        },
        /** 
         * @param filename Name of print job
         * @param file File that needs to be printed (.gcode, .gcode.gz)
         */
        jobsPost(params: {  "filename": string; "file": any; }, options?: any) {
            return DefaultApiFp.jobsPost(params, options)(fetch, basePath);
        },
        /** 
         */
        printersGet(options?: any) {
            return DefaultApiFp.printersGet(options)(fetch, basePath);
        },
        /** 
         * Add a new printer to the cluster. This will first add the printer to the discoveredprinters list if it is not there, and then will handle authentication. When authentication was succesful it will be added to the normal printer list.
         * @param hostname Hostname of printer to be added to the cluster. Either this and/or IP needs to be set. In case both are set, hostname is checked first.
         * @param ip IP of printer to be added to the cluster. Either this and/or hostname needs to be set. In case both are set, hostname is checked first.
         */
        printersPost(params: {  "hostname"?: string; "ip"?: string; }, options?: any) {
            return DefaultApiFp.printersPost(params, options)(fetch, basePath);
        },
        /** 
         * Remove a printer from the cluster [NOT YET IMPLEMENTED]
         * @param uuid uuid of the printer to delete
         */
        printersUuidDelete(params: {  "uuid": string; }, options?: any) {
            return DefaultApiFp.printersUuidDelete(params, options)(fetch, basePath);
        },
        /** 
         * @param uuid uuid of the printer to get
         */
        printersUuidGet(params: {  "uuid": string; }, options?: any) {
            return DefaultApiFp.printersUuidGet(params, options)(fetch, basePath);
        },
    };
};

